image: 'gpschaefer/rust:latest'

.rust-template: &rust-template
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
    CARGO_HOME: $CI_PROJECT_DIR/cargo
  before_script:
    - rustc --version
    - cargo --version
  cache:
    paths:
      - target/
      - $CARGO_HOME

stages:
  - build
  - test
  - coverage

build:
  <<: *rust-template
  stage: build
  script:
    - cargo build --verbose --all

#test:
#  <<: *rust-template
#  stage: test
#  script:
#    - cargo test --verbose --all
#
#coverage:
#  <<: *rust-template
#  stage: coverage
#  variables:
#    LLVM_PROFILE_FILE: "coverage-%p-%m.profraw"
#  script:
#    - find . -type f -name "*.profraw" -exec rm {} \;
#    - RUSTFLAGS="-C instrument-coverage" cargo test --lib --bins --target x86_64-unknown-linux-gnu
#    - grcov . --binary-path ./target/x86_64-unknown-linux-gnu/debug/ -s . -t cobertura --branch --ignore-not-existing --ignore "/*" --ignore "target/*" --ignore "*cargo*" --ignore "irradiance_gl/*" -o coverage.xml
#    - grcov . --binary-path ./target/x86_64-unknown-linux-gnu/debug/ -s . -t lcov --branch --ignore-not-existing --ignore "/*" --ignore "target/*" --ignore "*cargo*" --ignore "irradiance_gl/*" -o coverage.lcov
#    - lcov --summary coverage.lcov
#  artifacts:
#    paths:
#      - coverage.lcov
#    reports:
#      coverage_report:
#        coverage_format: cobertura
#        path: coverage.xml
